program nohigh(input, output);
(* nohigh: no high order characters in output

  Thomas D. Schneider, Ph.D.
  toms@alum.mit.edu
  toms@alum.mit.edu (permanent)
  https://alum.mit.edu/www/toms (permanent)

 *)

label 1; (* end of program *)

const
(* begin module version *)
   version = 1.00; (* of nohigh.p 2011 Apr 05
2011 Apr 05, 1.00: origin
*)
updateversion = 1.00; (* defines lowest acceptable current parameter file *)
(* end module version *)

(* begin module describe.nohigh *)
(*
name
   nohigh: no high order characters in output

synopsis
   nohigh(input: in, output: out)

files

   input:  a file

   output: the input file with high order characters removed

description

   The input is copied to the output but ASCII characters that are 127
   or higher are dropped.

examples

documentation

see also

author

   Thomas Dana Schneider

bugs

technical notes

*)
(* end module describe.nohigh *)

(* begin module halt *)
procedure halt;
(* stop the program.  the procedure performs a goto to the end of the
   program.  you must have a label:
      label 1;
   declared, and also the end of the program must have this label:
      1: end.
   examples are in the module libraries.
   this is the only goto in the delila system. *)
begin
      writeln(output,' program halt.');
      goto 1
end;
(* end module halt version = 'delmod 6.16 84 mar 12 tds/gds'; *)

(* begin module nohigh.themain *)
procedure themain;
(* the main procedure of the program *)
const
   debugging = false; (* debug output mode *)
var
   c: char; (* a character from the input *)
   n: integer; (* line counter*)
begin
{
   writeln(output,'nohigh ',version:4:2);
}

   reset(input);
   rewrite(output);

   n := 0;
   while not eof(input) do begin
      if debugging then writeln(output,n:1);
      if eoln(input)
      then begin
         writeln(output);
         readln(input);
      end
      else begin
         read(input,c);
         if debugging then write(output,c);
         if ord(c) < 127 then write(output,c);
      end;
      if debugging then n := succ(n);
   end;
end;
(* end module nohigh.themain *)

begin
   themain;
1: end.
