program quoteline(input, output);
(* quoteline: add quote marks to the beginning of every line in a file

  Tom Schneider
  network address: toms@alum.mit.edu


 *)

label 1; (* end of program *)

const
(* begin module version *)
version = 1.01; (* of quoteline.p 1993 February 5
origin 1993 Feb 4 from number.p *)
(* end module version *)

(* begin module describe.quoteline *)
(*
name
   quoteline: add quote marks to the beginning of every line in a file

synopsis
   quoteline(input: in, output: out)

files
   input:  input file
   output: input file with " at the start of every line

description
   Add quotes to the input file.  This allows generation of moo notes easily.
   One may "cut and paste" pieces of the file into a @edit of a note, and the
   lines will be added to the file.  Crude but effective.

examples

documentation

see also

author
   Thomas Dana Schneider

bugs
   A poor way to do things.  Ftp would be better.

technical notes

*)
(* end module describe.quoteline *)

(* begin module halt *)
procedure halt;
(* stop the program.  the procedure performs a goto to the end of the
   program.  you must have a label:
      label 1;
   declared, and also the end of the program must have this label:
      1: end.
   examples are in the module libraries.
   this is the only goto in the delila system. *)
begin
      writeln(output,' program halt.');
      goto 1
end;
(* end module halt version = 4.11; (@ of prgmod.p 1991 Apr 22 *)

(* begin module copyaline *)
procedure copyaline(var fin, fout: text);
(* copy a line from file fin to file fout *)
begin (* copyaline *)
      while not eoln(fin) do begin
         fout^ := fin^;
         put(fout);
         get(fin)
      end;
      readln(fin);
      writeln(fout);
end; (* copyaline *)
(* end module copyaline version = 4.11; (@ of prgmod.p 1991 Apr 22 *)

(* begin module quoteline.themain *)
procedure themain(var fin,fout: text);
(* the main procedure of the program *)
begin
   (* copy the file *)
   reset(fin);
   while not eof(fin) do begin
      write(fout,'"');
      copyaline(fin,fout)
   end;
end;
(* end module quoteline.themain *)

begin
   themain(input,output);
1: end.
