program wl(input,output);
(* wl: wrap lines in a file
   Tom Schneider, 1988 *)

const
(* begin module version *)
version = 1.00; (* of wl
origin 1990 May 9 *)
(* end module version *)

(* begin module describe.wl *)
(*
name
   wl: wrap lines in a file

synopsis
   wl(input: in, output: out)

files
   input:  text to be wrapped
   output: wrapped text

description
   This Pascal program takes ASCII text and filters it.  Lines longer than the
constant maxline are altered by inserting carriage returns.

author
   Thomas Dana Schneider

see also
    ww.p

bugs
   the constant maxline is fixed at compile time.

*)
(* end module describe.wl *)

    maxline = 80; (* maximum width of output lines *)

var
   c: char; (* a character in the input *)
   n: integer; (* number of characters written to output so far *)
begin
  while not eof(input) do begin
    n := 0; (* no characters written out so far on this line *)
    while not eoln(input) do begin
      read(input,c);
      if n >= maxline then begin
         writeln(output);
         n := 0;
      end;
      write(output,c);
      n := n + 1;
    end;

    readln(input);
    writeln(output);
  end
end.
