program worcharev(worchap, reversed, output);
(* worcharev: wordchange reverse

  Tom Schneider
  toms@alum.mit.edu
  https://alum.mit.edu/www/toms/


 *)

label 1; (* end of program *)

const
(* begin module version *)
version = 1.00; (* of worcharev.p 1996 September 12
origin 1996 September 12 *)
(* end module version *)

(* begin module describe.worcharev *)
(*
name
   worcharev: wordchange reverse

synopsis
   worcharev(worchap: in, reversed: out, output: out)

files
   worchap:  the parameter file for worcha.
   reversed:  the parameter file for worcha, with even and odd lines
      reversed.
   output: messages to the user

description
   Sometimes one would like to reverse the direction that worcha
   converts words.  This program goes through the worchap file
   and switches each line with the next one so that worcha
   will work the other way.

examples

documentation

see also
   worcha.p

author
   Thomas Dana Schneider

bugs

technical notes

*)
(* end module describe.worcharev *)

var
   reversed, (* file used by this program *)
   worchap: text; (* file used by this program *)

(* begin module halt *)
procedure halt;
(* stop the program.  the procedure performs a goto to the end of the
   program.  you must have a label:
      label 1;
   declared, and also the end of the program must have this label:
      1: end.
   examples are in the module libraries.
   this is the only goto in the delila system. *)
begin
      writeln(output,' program halt.');
      goto 1
end;
(* end module halt version = 4.18; (@ of prgmod.p 1996 September 12 *)

(* begin module copyaline *)
procedure copyaline(var fin, fout: text);
(* copy a line from file fin to file fout *)
begin (* copyaline *)
      while not eoln(fin) do begin
         fout^ := fin^;
         put(fout);
         get(fin)
      end;
      readln(fin);
      writeln(fout);
end; (* copyaline *)
(* end module copyaline version = 4.18; (@ of prgmod.p 1996 September 12 *)

(* begin module worcharev.themain *)
procedure themain(var worchap, reversed: text);
(* the main procedure of the program *)
var
   f: text; (* temporary internal file *)
begin
   writeln(output,'worcharev ',version:4:2);

   reset(worchap);
   rewrite(reversed);

   while not eof(worchap) do begin
      rewrite(f);
      copyaline(worchap, f);

      if eof (worchap) then begin
         writeln(output,'error in worchap:',
			' there must be an even number of lines.');
         halt
      end;

      copyaline(worchap, reversed);
      reset(f);
      copyaline(f, reversed);
   end;

end;
(* end module worcharev.themain *)

begin
   themain(worchap, reversed);
1: end.
